(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-star-rating', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-star-rating"] = {}, global.ng.core, global.ng.forms, global.ng.common));
})(this, (function (exports, i0, forms, common) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var NgxStarRatingService = /** @class */ (function () {
        function NgxStarRatingService() {
        }
        return NgxStarRatingService;
    }());
    NgxStarRatingService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function NgxStarRatingService_Factory() { return new NgxStarRatingService(); }, token: NgxStarRatingService, providedIn: "root" });
    NgxStarRatingService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    NgxStarRatingService.ctorParameters = function () { return []; };

    var NgxStarRatingComponent = /** @class */ (function () {
        function NgxStarRatingComponent() {
            this.stars = [5, 4, 3, 2, 1];
            this.propagateChange = function (_) { };
            if (!this.disabled) {
                this.disabled = false;
            }
        }
        NgxStarRatingComponent.prototype.ngOnInit = function () { };
        NgxStarRatingComponent.prototype.rate = function (rate) {
            if (!this.disabled) {
                this.propagateChange(rate);
            }
        };
        NgxStarRatingComponent.prototype.writeValue = function (value) {
            if (this.ngxCheckbox && value === null) {
                this.ngxCheckbox.forEach(function (checkbox) {
                    checkbox.nativeElement.checked = false;
                });
            }
            this.value = value;
        };
        NgxStarRatingComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        NgxStarRatingComponent.prototype.registerOnTouched = function (fn) { };
        return NgxStarRatingComponent;
    }());
    NgxStarRatingComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'ngx-star-rating',
                    template: "<form action=\"\">\r\n  <ng-template ngFor let-star [ngForOf]=\"stars\" let-i=\"index\">\r\n    <input #ngxCheckbox class=\"star star-{{ star }}\" id=\"star-{{ star }}-{{ id }}\" type=\"radio\" name=\"star\" (click)=\"rate(star)\"\r\n      [checked]=\"value == star\" [disabled]=\"disabled\" />\r\n    <label class=\"star star-{{ star }}\" for=\"star-{{ star }}-{{ id }}\"></label>\r\n  </ng-template>\r\n</form>\r\n",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: i0.forwardRef(function () { return NgxStarRatingComponent; }),
                            multi: true,
                        }
                    ],
                    styles: ["@charset \"UTF-8\";*{margin:0;padding:0;font-family:roboto}body{background:#000}.cont{width:93%;max-width:350px;text-align:center;margin:4% auto;padding:30px 0;background:#111;color:#eee;border-radius:5px;border:thin solid #444;overflow:hidden}hr{margin:20px;border:none;border-bottom:thin solid rgba(255,255,255,.1)}div.title{font-size:2em}h1 span{font-weight:300;color:#fd4}div.stars{width:270px;display:inline-block}input.star{display:none}label.star{float:right;padding:10px;font-size:36px;color:#444;transition:all .2s}input.star:checked~label.star:before{content:\"\\f005\";color:#fd4;transition:all .25s}input.star-5:checked~label.star:before{color:#fe7;text-shadow:0 0 20px #952}input.star-1:checked~label.star:before{color:#f62}label.star:hover{transform:rotate(-15deg) scale(1.3)}label.star:before{content:\"\\f006\";font-family:FontAwesome}\n"]
                },] }
    ];
    NgxStarRatingComponent.ctorParameters = function () { return []; };
    NgxStarRatingComponent.propDecorators = {
        id: [{ type: i0.Input }],
        disabled: [{ type: i0.Input }],
        ngxCheckbox: [{ type: i0.ViewChildren, args: ['ngxCheckbox',] }]
    };

    var NgxStarRatingModule = /** @class */ (function () {
        function NgxStarRatingModule() {
        }
        return NgxStarRatingModule;
    }());
    NgxStarRatingModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [NgxStarRatingComponent],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [NgxStarRatingComponent]
                },] }
    ];

    /*
     * Public API Surface of ngx-star-rating
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxStarRatingComponent = NgxStarRatingComponent;
    exports.NgxStarRatingModule = NgxStarRatingModule;
    exports.NgxStarRatingService = NgxStarRatingService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-star-rating.umd.js.map
